from AccessControl import ClassSecurityInfo
from Products.PageTemplates.PageTemplateFile import PageTemplateFile
from Globals import InitializeClass

# Silva
from Products.Silva import SilvaPermissions
from Products.Silva import IVersionedContent
from Products.Silva.Document import Document
from Products.Silva.helpers import add_and_edit

# from SampleEditorSupport import SampleEditorSupport

class Agenda(Document):

    security = ClassSecurityInfo()
    
    meta_type = "Silva Sample Meeting Agenda"

    # XXX why do we explicitly have this ?
    __implements__ = IVersionedContent.IVersionedContent
    
    # get a Silva tab in between the standard ZMI tabs
    manage_options=Document.manage_options

    def __init__(self, id, title):
        Agenda.inheritedAttribute('__init__')(self, id, title)

    security.declareProtected(SilvaPermissions.ChangeSilvaContent,
                              'new_talk')    
    def new_talk(self, node):
        """ create a new talk node.
            the node is returned, but not inserted
            somewhere in the node (do not know, where ...)
        """
        # first get the document
        if node.nodeType == node.DOCUMENT_NODE:
            doc = node
        else:
            doc = node.ownerDocument
        talk = doc.createElement('talk')
        for name in ('start_time', 'end_time', 'speaker', 'talk_title', 'abstract'):
            child = doc.createElement(name)
            talk.appendChild(child)
        return talk

    
InitializeClass(Agenda)

manage_addAgendaForm = PageTemplateFile("www/agendaAdd", globals(),
                                        __name__='manage_addAgendaForm')

def manage_addAgenda(self, id, title, REQUEST=None):
    """Add an "Agenda". """
    if not self.is_id_valid(id):
        return
    object = Agenda(id, title)
    self._setObject(id, object)
    object = getattr(self, id)
    # add a ParsedXML object with dummy content
    xmlstr = '<agenda/>'
    object.manage_addProduct['ParsedXML'].manage_addParsedXML('0', '', xmlstr)
    object.create_version('0', None, None)
    version=getattr(object,'0')
    add_and_edit(self, id, REQUEST)
    return ''



