# import necessary definitions from:
# Zope
from Globals import InitializeClass
from OFS.SimpleItem import SimpleItem
from AccessControl import ClassSecurityInfo
from Products.PageTemplates.PageTemplateFile import PageTemplateFile
# Silva interfaces
from Products.Silva.IVersionedContent import IVersionedContent
# Silva
from Products.Silva import SilvaPermissions
from Products.Silva.VersionedContent import VersionedContent
from Products.Silva.helpers import add_and_edit, translateCdata
# misc
from cgi import escape
icon="www/blob.gif"

class Blob(VersionedContent):
    """Silva Sample Blob content type.
    """
    security = ClassSecurityInfo()

    meta_type = "Silva Sample Blob"

    __implements__ = IVersionedContent

    def __init__(self, id, title):
       """The constructor, does not do much in this case (just maps to
          the constructor of the parent).
       """
       Blob.inheritedAttribute('__init__')(self, id, title)

InitializeClass(Blob)


class BlobVersion(SimpleItem):
    """version class for the Silva Sample Blob
    """
    security = ClassSecurityInfo()

    meta_type = "Silva Sample Blob Version"

    def __init__(self, id):
       """Set id and initialize other attributes
       """
       self.id = id
       self._text = u''

    security.declareProtected(SilvaPermissions.AccessContentsInformation,
                             'get_text')
    def get_text(self):
       """Get the text for this blob version.
       """
       return self._text

    security.declareProtected(SilvaPermissions.ChangeSilvaContent,
                             'set_text')
    def set_text(self, text):
       """Sets the text of the blob version"""
       self._text = text

InitializeClass(BlobVersion)

manage_addBlobForm = PageTemplateFile("www/blobAdd", globals(),
                                        __name__='manage_addBlobForm')

def manage_addBlob(self, id, title, REQUEST=None):
    """Add a Blob to some Silva container."""
    if not self.is_id_valid(id):
       return
    object = Blob(id, title)
    self._setObject(id, object)
    object = getattr(self, id)
    # add first version
    object._setObject('0', BlobVersion('0'))
    object.create_version('0', None, None)
    add_and_edit(self, id, REQUEST)
    return ''

manage_addBlobVersionForm = PageTemplateFile("www/blobVersionAdd", globals(),
                                        __name__='manage_addBlobVersionForm')

def manage_addBlobVersion(self, id, title, REQUEST=None):
    """Add a Blob version to the Silva-instance."""
    object = BlobVersion(id, title)
    self._setObject(id, object)
    add_and_edit(self, id, REQUEST)
    return ''