
# Zope
from AccessControl import ClassSecurityInfo
from Globals import InitializeClass
from Products.ParsedXML.ParsedXML import ParsedXML
from Products.PageTemplates.PageTemplateFile import PageTemplateFile

# Silva interfaces
from Products.Silva.IVersionedContent import IVersionedContent

# Silva
from Products.Silva.VersionedContent import VersionedContent
from Products.Silva.Document import Document
from Products.Silva.helpers import add_and_edit

icon='www/sampledoc.gif'

class SampleDocument(Document):
    """Mildly customized Sample Document.
    """
    security = ClassSecurityInfo()
    
    meta_type = "Silva Sample Document"

    __implements__ = IVersionedContent
    
    manage_options = Document.manage_options

    def __init__(self, id, title):
        SampleDocument.inheritedAttribute('__init__')(self, id, title)


InitializeClass(SampleDocument)

manage_addSampleDocumentForm = PageTemplateFile("www/sampleDocumentAdd", globals(),
                                                __name__='manage_addSampleDocumentForm')

def manage_addSampleDocument(self, id, title, headline=None, REQUEST=None):
    """Add a Document."""
    if not self.is_id_valid(id):
        return
    object = SampleDocument(id, title)
    self._setObject(id, object)
    object = getattr(self, id)
    # add empty ParsedXML object
    str = """<doc><disptitle></disptitle></doc>"""
    object.manage_addProduct['ParsedXML'].manage_addParsedXML('0', '', str)
    object.create_version('0', None, None)
    v = object.get_editable()
    # XXX this is quite stupid now ... but the title is already encoded
    if not headline:
        headline = object.output_convert_editable(title)
    object.replace_heading(v.documentElement.firstChild, headline)
    add_and_edit(self, id, REQUEST)
    return ''
