## "render_childs"
##bind context=context

node = context.REQUEST.node
form = context.get_form()
viewer = context.service_editor.getViewer()
content = {}


for child in node.childNodes:
   if child.nodeType != child.ELEMENT_NODE:
     continue
   name = child.nodeName

   if viewer.hasWidget(child):
      c = viewer.getWidget(child).render()
   elif form.has_field(name):
      field = form.get_field(name)
      meta_type = field.meta_type
      if meta_type =='StringField':
        c = node.render_heading_as_html(child)
      elif meta_type =='TextAreaField':
        c = node.render_text_as_html(child)
      elif meta_type=='DateTimeField':
        from DateTime import DateTime
        # XXX what if not mandatory ?
        date = DateTime(long(float(node.render_heading_as_editable(child))))
        if field.get_value('date_only'):
            c = context.sample_util.render_day(date)
        else:
            c = context.sample_util.render_date_time(date)
        # XXX what, if time only ???
      
      else:
        # XXX what if list ? maybe add properties?    
        raise TypeError, 'fixed_size_top generic mode_view does not support field type '+meta_type+' for node name '+name
   else:
      raise ValueError, 'fixed_size_top generic mode_view: no view for node name '+name+' in widget registry '+viewer.getId()

   # ... to better track stupid encoding erros
   if same_type(c, u' '):
     raise TypeError, 'Unicode for node '+name
  
   content[name] = c

return content
